<template>
  <div>
    <div id="teacher_class_reportiong_wrapper" class="bt-container">
      <el-breadcrumb style="font-size: 24px; margin-top: 40px; margin-bottom: 40px;" separator="|">
        <el-breadcrumb-item :to="{ path: `/a/${authType ? 'teacher' : 'student'}/NNclass/${classId}` }">{{ class_name }}
        </el-breadcrumb-item>
        <el-breadcrumb-item>{{ $t('CLASS_MENU.ATTEND_MANAGE') }}</el-breadcrumb-item>
        <div style="text-align: right;">
          <a href="javascript:history.back();">
            <el-button size="small">{{ $t('BOARD.BACK') }}</el-button>
          </a>
        </div>
      </el-breadcrumb>
      <el-table id="items" :data="attendList">
        <el-table-column align="center" prop="lec_name" label="세션명">
        </el-table-column>
        <el-table-column align="center" prop="attend_date" label="출석일">
        </el-table-column>
        <el-table-column align="center" prop="attending" label="출석 유무">
        </el-table-column>
      </el-table>

    </div>
  </div>
</template>
<script>
  import {
    mapActions,
    mapState,
    mapGetters,
    mapMutations
  } from 'vuex';
  import classService from '../../services/classService';
  import attendService from '../../services/attendService';
  import utils from '../../utils';
  

  export default {
    name: 'ReportLectureItem',
    props: ['itemType'],
    async created() {
      const vm = this;
      const res = await classService.getClass({ // 해당 과목의 모든 강의 불러오기
        id: vm.classId,
      });
      let lectureIds = "";
      let lectureAuths = [];
      res.data.lectures.forEach(lec => {
        if (lec.type === 0) {
          lectureIds += lec.lecture_id + "$";
        }
      });
      lectureAuths = await attendService.getAllLectureAuths({
        lectureIds: lectureIds,
      });
      lectureAuths.data.forEach(lec => {
        for (let i = 0; i < res.data.lectures.length; i++) {
          const lec_id = res.data.lectures[i].lecture_id;
          if (lec.length > 1) {
            for (let j = 1; j < lec.length; j++) {
              if (lec[j].createdAt.split('T')[0] === lec[0].createdAt.split('T')[0]) {
                lec.pop(j);
                j--;
                continue;
              }
              if (lec[j].lecture_id === lec_id) {
                lec[j].name = res.data.lectures[i].name;
              }
            }
          } else if (lec.length === 1) {
            if (lec[0].lecture_id === lec_id) {
              lec[0].name = res.data.lectures[i].name;
              break;
            }
          }
        }
      });
      vm.class_name = res.data.name;
      const res2 = await attendService.getSTDAuths({ // 해당 학생의 모든 출석기록 불러오기
        studentId: vm.userId,
      });
      // 출석기록에 해당 강의가 있으면 출석으로 간주. 없으면 결석으로 간주.
      const lectures = lectureAuths.data;
      const authen = res2.data;
      for (let i = 0; i < lectures.length; i++) {
        const lec = lectures[i];
        for (let k = 0; k < lec.length; k++) {
          let tmpList = [];
          for (let j = 0; j < authen.length; j++) {
            if (lec[k].lecture_id === authen[j].lecture_id) {
              tmpList.push(authen[j]);
            }
          }
          // 한 강의에 서로 다른 날짜의 출석기록이 있으면 복수 저장
          if (tmpList.length > 0) {
            if (tmpList.length === 1) {
              let obj = {};
              obj.lec_name = lec[k].name;
              obj.attend_date = authen[0].createdAt.split('T')[0];
              obj.attending = '출석';
              vm.attendList.push(obj);
            } else if (tmpList.length > 1) {
              let tmpDate = authen[0].createdAt.split('T')[0];
              for (let k = 1; k < tmpList.length; k++) {
                if (tmpList[k].createdAt.split('T')[0] !== tmpDate) {
                  let obj = {};
                  obj.lec_name = lec[k].name;
                  obj.attend_date = tmpList[k].createdAt.split('T')[0];
                  obj.attending = '출석';
                  vm.attendList.push(obj);
                  tmpDate = tmpList[k].createdAt.split('T')[0];
                }
              }
            }
          } else {
            let obj = {};
            obj.lec_name = lec[k].name;
            obj.attend_date = '.';
            obj.attending = '결석';
            vm.attendList.push(obj);
          }
        }
      }
    },
    data() {
      return {
        authenticationList: [],
        attendList: [],
        class_name: '',
      };
    },
    computed: {
      ...mapState('attendance', ['lectureList', 'curLectureItems', 'curLectureItems2', 'curStep', 'curLectureId']),
      ...mapGetters('NNclass', [
        'currentTeachingClass',
      ]),
      authType() {
        const vm = this;
        const jwt = vm.$store.state.auth.jwt;
        return utils.getAuthTypeFromJwt(jwt);
      },

      classId() {
        const vm = this;
        return Number.parseInt(vm.$route.params.classId, 10);
      },
      userId() {
        const vm = this;
        return Number.parseInt(vm.$route.params.userId, 10);
      }
    },
    methods: {
      ...mapActions('attendance', ['getLectureList', 'getLectureItemList', 'postLectureResult', 'getClassResult',
        'getStudentAuthenticationList'
      ]),
      ...mapMutations('attendance', ['updateCurStep', 'updateCurState']),
    },
  };

</script>
